/* $Id: translation.c,v 1.1.1.2 2004/08/12 15:20:17 roman Exp $ */
/* written by Roman R. Stocsits, 2004 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static char UniversalCodonTable[4][4][4]=
{
  {{'K','N','K','N'},{'I','I','M','I'},{'R','S','R','S'},{'T','T','T','T'}},  
  {{'*','Y','*','Y'},{'L','F','L','F'},{'*','C','W','C'},{'S','S','S','S'}},
  {{'E','D','E','D'},{'V','V','V','V'},{'G','G','G','G'},{'A','A','A','A'}},
  {{'Q','H','Q','H'},{'L','L','L','L'},{'R','R','R','R'},{'P','P','P','P'}}
};



char *translateORF(char *orf, char *CodonTableName);
/*  void use_me_this_way(void); */

/*-------------------------------------------------------------------------*/

char *translateORF(char *orf, char *CodonTableName){

  int i, j, p, l=0, orflen=0;
  short pos[3]={0,0,0};
  char *AASeq=NULL;
  int marker=0;
  
  if(orf) orflen=strlen(orf);
  AASeq=(char*)calloc((orflen/3)+1,sizeof(char));
  
  for(i=0; i< orflen-2; i+=3){
    for(j=i; j<i+3; j++){
      switch(orf[j]){
      case 'A': p=0;
	break;
      case 'U': p=1;
	break;
      case 'G': p=2;
	break;
      case 'C': p=3;
	break;
      case 'T': p=1;
	break;
      default: p=4;
	marker=1;
      }
      pos[j-i]=p;
    }
    if(marker){
      AASeq[l++]='X';
      marker=0;
      continue;
    }
    if(strcmp(CodonTableName,"univ")==0){
      AASeq[l++]=UniversalCodonTable[pos[0]][pos[1]][pos[2]];
      continue;
    }
    if(strcmp(CodonTableName,"acet")==0){
      if((pos[0]==(1))&&(pos[1]==(0))&&(pos[2]==(0))){
	AASeq[l++]=('Q');
	continue;
      }
      if((pos[0]==(1))&&(pos[1]==(0))&&(pos[2]==(2))){
	AASeq[l++]=('Q');
	continue;
      }
      else{
	AASeq[l++]=UniversalCodonTable[pos[0]][pos[1]][pos[2]];
      }
       continue;
    }
    if(strcmp(CodonTableName,"ccyl")==0){  
      if((pos[0]==(3))&&(pos[1]==(1))&&(pos[2]==(2))){
	AASeq[l++]=('S');
	continue;
      }
      else{
	AASeq[l++]=UniversalCodonTable[pos[0]][pos[1]][pos[2]];
      }
       continue;
    }
    if(strcmp(CodonTableName,"tepa")==0){  
      if((pos[0]==(1))&&(pos[1]==(0))&&(pos[2]==(0))){
	AASeq[l++]=('Q');
	continue;
      }
      if((pos[0]==(1))&&(pos[1]==(0))&&(pos[2]==(2))){
	AASeq[l++]=('Q');
	continue;
      }
      else{
	AASeq[l++]=UniversalCodonTable[pos[0]][pos[1]][pos[2]];
      }
       continue;
    }
    if(strcmp(CodonTableName,"eupl")==0){  
      if((pos[0]==(1))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('C');
	continue;
      }
      else{
	AASeq[l++]=UniversalCodonTable[pos[0]][pos[1]][pos[2]];
      }
       continue;
    } 
    if(strcmp(CodonTableName,"mlut")==0){  
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('*');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(1))&&(pos[2]==(0))){
	AASeq[l++]=('*');
	continue;
      }
      else{
	AASeq[l++]=UniversalCodonTable[pos[0]][pos[1]][pos[2]];
      }
       continue;
    }
    if(strcmp(CodonTableName,"mysp")==0){  
      if((pos[0]==(1))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('W');
	continue;
      }
      if((pos[0]==(3))&&(pos[1]==(2))&&(pos[2]==(2))){
	AASeq[l++]=('*');
	continue;
      }
      else{
	AASeq[l++]=UniversalCodonTable[pos[0]][pos[1]][pos[2]];
      }
       continue;
    }
    if(strcmp(CodonTableName,"mitocan")==0){  
      if((pos[0]==(3))&&(pos[1]==(0))){
	AASeq[l++]=('L');
	continue;
      }
      else{
	AASeq[l++]=UniversalCodonTable[pos[0]][pos[1]][pos[2]];
      }
       continue;
    }
    if(strcmp(CodonTableName,"mitovrt")==0){  
      if((pos[0]==(1))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('W');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(1))&&(pos[2]==(0))){
	AASeq[l++]=('M');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(0))&&(pos[2]==(0))){
	AASeq[l++]=('K');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('*');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(2))){
	AASeq[l++]=('*');
	continue;
      }
      if((pos[0]==(3))&&(pos[1]==(0))){
	AASeq[l++]=('L');
	continue;
      }  
      else{
	AASeq[l++]=UniversalCodonTable[pos[0]][pos[1]][pos[2]];
      }
       continue;
    }
    if(strcmp(CodonTableName,"mitoart")==0){  
      if((pos[0]==(1))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('W');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(1))&&(pos[2]==(0))){
	AASeq[l++]=('M');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(0))&&(pos[2]==(0))){
	AASeq[l++]=('K');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('S');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(2))){
	AASeq[l++]=('R');
	continue;
      }
      if((pos[0]==(3))&&(pos[1]==(0))){
	AASeq[l++]=('L');
	continue;
      }  
      else{
	AASeq[l++]=UniversalCodonTable[pos[0]][pos[1]][pos[2]];
      }
       continue;
    }
    if(strcmp(CodonTableName,"mitoech")==0){  
      if((pos[0]==(1))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('W');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(1))&&(pos[2]==(0))){
	AASeq[l++]=('I');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(0))&&(pos[2]==(0))){
	AASeq[l++]=('N');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('S');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(2))){
	AASeq[l++]=('S');
	continue;
      }
      if((pos[0]==(3))&&(pos[1]==(0))){
	AASeq[l++]=('L');
	continue;
      }  
      else{
	AASeq[l++]=UniversalCodonTable[pos[0]][pos[1]][pos[2]];
      }
       continue;
    }
    if(strcmp(CodonTableName,"mitomol")==0){  
      if((pos[0]==(1))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('W');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(1))&&(pos[2]==(0))){
	AASeq[l++]=('M');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(0))&&(pos[2]==(0))){
	AASeq[l++]=('K');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('S');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(2))){
	AASeq[l++]=('S');
	continue;
      }
      if((pos[0]==(3))&&(pos[1]==(0))){
	AASeq[l++]=('L');
	continue;
      }  
      else{
	AASeq[l++]=UniversalCodonTable[pos[0]][pos[1]][pos[2]];
      }
       continue;
    }
    if(strcmp(CodonTableName,"mitoasc")==0){  
      if((pos[0]==(1))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('W');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(1))&&(pos[2]==(0))){
	AASeq[l++]=('M');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(0))&&(pos[2]==(0))){
	AASeq[l++]=('K');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('G');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(2))){
	AASeq[l++]=('G');
	continue;
      }
      if((pos[0]==(3))&&(pos[1]==(0))){
	AASeq[l++]=('L');
	continue;
      }  
      else{
	AASeq[l++]=UniversalCodonTable[pos[0]][pos[1]][pos[2]];
      }
       continue;
    }
    if(strcmp(CodonTableName,"mitonem")==0){  
      if((pos[0]==(1))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('W');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(1))&&(pos[2]==(0))){
	AASeq[l++]=('M');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(0))&&(pos[2]==(0))){
	AASeq[l++]=('?');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('S');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(2))){
	AASeq[l++]=('S');
	continue;
      }
      if((pos[0]==(3))&&(pos[1]==(0))){
	AASeq[l++]=('?');
	continue;
      }
      if((pos[0]==(1))&&(pos[1]==(0))&&(pos[2]==(0))){
	AASeq[l++]=('?');
	continue;
      }
      else{
	AASeq[l++]=UniversalCodonTable[pos[0]][pos[1]][pos[2]];
      }
       continue;
    }
    if(strcmp(CodonTableName,"mitopla")==0){  
      if((pos[0]==(1))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('W');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(1))&&(pos[2]==(0))){
	AASeq[l++]=('I');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(0))&&(pos[2]==(0))){
	AASeq[l++]=('N');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('S');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(2))){
	AASeq[l++]=('S');
	continue;
      }
      if((pos[0]==(3))&&(pos[1]==(0))){
	AASeq[l++]=('?');
	continue;
      }
      if((pos[0]==(1))&&(pos[1]==(0))&&(pos[2]==(0))){
	AASeq[l++]=('?');
	continue;
      }
      else{
	AASeq[l++]=UniversalCodonTable[pos[0]][pos[1]][pos[2]];
      }
       continue;
    }
    if(strcmp(CodonTableName,"mitoyea")==0){  
      if((pos[0]==(1))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('W');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(1))&&(pos[2]==(0))){
	AASeq[l++]=('M');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(0))&&(pos[2]==(0))){
	AASeq[l++]=('K');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('R');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(2))){
	AASeq[l++]=('R');
	continue;
      }
      if((pos[0]==(3))&&(pos[1]==(0))){
	AASeq[l++]=('T');
	continue;
      }
      else{
	AASeq[l++]=UniversalCodonTable[pos[0]][pos[1]][pos[2]];
      }
       continue;
    }
    if(strcmp(CodonTableName,"mitoeua")==0){  
      if((pos[0]==(1))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('W');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(1))&&(pos[2]==(0))){
	AASeq[l++]=('I');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(0))&&(pos[2]==(0))){
	AASeq[l++]=('K');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('R');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(2))){
	AASeq[l++]=('R');
	continue;
      }
      if((pos[0]==(3))&&(pos[1]==(0))){
	AASeq[l++]=('L');
	continue;
      }
      else{
	AASeq[l++]=UniversalCodonTable[pos[0]][pos[1]][pos[2]];
      }
       continue;
    }
    if(strcmp(CodonTableName,"mitopro")==0){  
      if((pos[0]==(1))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('W');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(1))&&(pos[2]==(0))){
	AASeq[l++]=('I');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(0))&&(pos[2]==(0))){
	AASeq[l++]=('K');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(0))){
	AASeq[l++]=('R');
	continue;
      }
      if((pos[0]==(0))&&(pos[1]==(2))&&(pos[2]==(2))){
	AASeq[l++]=('R');
	continue;
      }
      if((pos[0]==(3))&&(pos[1]==(0))){
	AASeq[l++]=('L');
	continue;
      }
      else{
	AASeq[l++]=UniversalCodonTable[pos[0]][pos[1]][pos[2]];
      }
      continue;
    }
    else {
      fprintf(stdout, "\nTranslation failure!\nCodon table name incorrect?\n");
    }
  }
  AASeq[l]='\0';
  return(AASeq);
}
